#                    an example of script in sirc
#                          by orabidoo '95
#
#            .''',   ||    '||                                     '||` 
#            |   |   ||     ||      ''                              ||  
#   `||''|,  |   | ''||''   ||''|,  ||  `||''|,  .|''|,    '||''|,  ||  
#    ||  ||  |   |   ||     ||  ||  ||   ||  ||  ||  ||     ||  ||  ||  
#   .||  ||. `,,,'   `|..' .||  || .||. .||  ||. `|..|| ..  ||..|' .||. 
#                                                    ||     ||          
#                                                 `..|'    .||          
#
#
#      does all the missing applicable stuff from my ircII script zer0
#                    to load it in sirc, /load n0thing.pl
#
# renamed from zer0.pl to n0thing.pl, to avoid confusing with the ircII script
#
# version 2.1, last modified: 7 Nov 1995
# recent improvements: /fk not kick yourself, /unban user@host, timestamp
#		       and userhost on logged messages



$add_ons.="+n0thing-v2.1.pl" if ($add_ons !~ /n0thing/);

$n_isaway='';
$n_awayfile=$ENV{"HOME"}."/.n0thing-pl.mes";
$n_svefile=$ENV{"HOME"}."/.n0thing-pl.sve";

$n_autoops=1;
$n_autorejoin=1;
$n_slowserver='';
@n_autooplist=();
$n_opdelay=5;

$n_pingmsg="I'm not lagged, but you surely are";
$n_quitmsg='';

# time saving aliases

&docommand("^alias fing ctcp \$0 finger");
&docommand("^alias ver ctcp \$0 version");
&docommand("^alias tim ctcp \$0 time");
&docommand("^alias ex system");
&docommand("^alias ls system ls -al");
&docommand("^alias cat system cat");
&docommand("^alias rm system rm");
&docommand("^alias ps system ps");
&docommand("^alias mail system mail");

sub cmd_open {
  &getarg;
  $newarg=$talkchannel unless $newarg;
  &tell("*\cbE\cb* Huh? what channel?"), return unless $newarg;
  $newarg =~ tr/A-Z/a-z/;
  &sl("MODE $newarg -lsmpik ".$chankey{$newarg});
}
&addcmd("open");

sub cmd_l {
  if ($talkchannel) {
    &sl("LIST $talkchannel");
    &sl("NAMES $talkchannel");
  }
}
&addcmd("l");

# dcc related stuff

&docommand("^alias ds dcc send");
&docommand("^alias dl dcc list");
&docommand("^alias cdc dcc close chat");
&docommand("^alias cdg dcc close get");
&docommand("^alias cds dcc close send");

sub cmd_dc {
  &getarg;
  if ($newarg) {
    &docommand("dcc chat $newarg");
  } elsif ($n_lastdc) {
    &docommand("dcc chat $n_lastdc");
    $n_lastdc='';
  }
}
&addcmd("dc");

sub cmd_dg {
  &getarg;
  if ($newarg) {
    &docommand("dcc get $newarg $args");
  } elsif ($n_lastdcc) {
    &docommand("dcc get $n_lastdcc");
    $n_lastdcc='';
  }
}
&addcmd("dg");

# hooks

sub hook_ctcp {
  if ($_[1] eq 'PING') {
    &sl("NOTICE $who :\caPONG ".$n_pingmsg."\ca");
  } elsif ($_[1] eq 'DCC') {
    $n_lastdcc=$who if $_[2] =~ /^SEND /;
    $n_lastdc=$who if $_[2] =~ /^CHAT /;
  }
}
&addhook("ctcp", "ctcp");

sub hook_kicked {
  local($kicked, $where_from, $reason)=@_;                           
  if ($n_autorejoin && &eq($kicked, $nick)) {
    &sl("JOIN $where_from $chankey{$where_from}");
  }
}
&addhook("kick", "kicked");

sub hook_uhnotify {
  unless ($n_slowserver) {
    &userhost($_[0], "&tell(\"*\cb)\cb* Signon by $_[0] (\$user\\\@\$host) detected!\");", "");
    $silent=1;
  }
} 
&addhook("notify_signon", "uhnotify");

# settings

sub cmd_rejoin {
  &getarg;
  $n_autorejoin=($newarg =~ /^on$/i) if ($newarg =~ /^on$|^off$/i);
  &tell("*\cb0\cb* Auto-rejoin is ".($n_autorejoin?"on":"off"));
}
&addcmd("rejoin");

sub cmd_ss {
  &getarg;
  $n_slowserver=($newarg =~ /^on$/i) if ($newarg =~ /^on$|^off$/i);
  &tell("*\cb0\cb* Slow-server is ".($n_slowserver?"on":"off"));
}
&addcmd("ss");

sub cmd_setping {
  $n_pingmsg=$args if $args;
  &tell("*\cb0\cb* Your ping reply is: $n_pingmsg");
}
&addcmd("setping");

sub cmd_setfing {
  $finger=$args if $args;
  &tell("*\cb0\cb* Your finger reply is: $finger");
}
&addcmd("setfing");

sub cmd_setquit {
  $n_quitmsg=$args if $args;
  $n_quitmsg='' if $args eq 'none';
  if ($n_quitmsg ne '') {
    &tell("*\cb0\cb* Your quit message is: $n_quitmsg");
  } else {
    &tell("*\cb0\cb* You don't have a quit message set");
  }
}
&addcmd("setquit");

# ignores

sub cmd_ig {
  &docommand("ignore $args"), return if (!$args || $args =~ /^-/);
  &getarg;
  if ($newarg =~ /\@/) {
    $n_lastignore=$newarg;
    &docommand("ignore $newarg");
  } else {
    &userhost($newarg, "\$host=&n_hostpat(\$host); \$user =~ s/^\\~//; \$n_lastignore=\"*\$user\\\@\$host\"; &docommand(\"ignore *\$user\\\@\$host\");");
  }
}
&addcmd("ig");

sub cmd_sig {
  &getarg;
  &userhost($newarg, "\$host=&n_hostpat(\$host); \$n_lastignore=\"*\\\@\$host\"; &docommand(\"ignore *\\\@\$host\");");
}
&addcmd("sig");

sub cmd_unig {
  &docommand("ignore -$n_lastignore") if $n_lastignore;
  $n_lastignore='';
}
&addcmd("unig");

# bans and unbans

sub n_hostpat {
  if ($_[0] =~ /^(\d+)\.(\d+)\.(\d+)\.(\d+)$/) {
    return "${1}.${2}.${3}.*";
  } elsif ($_[0] =~ /^([^. \t]+)\.([^. \t]+)\.(.*)$/) {
    return "*.${2}.${3}";
  } else {
    return $_[0];
  }
}

sub cmd_kb {
  &getarg;
  local($why)=($args);
  $why="game over, man.  game over." unless $why;
  &tell("*\cb0\cb* Must specify a nick to kickban"), return unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&n_hostpat(\$host); \$user =~ s/^\\~//;
&sl(\"MODE $talkchannel -o+b $newarg *!*\$user\\\@\$host\");
&sl(\"KICK $talkchannel $newarg :$why\");");
}
&addcmd("kb");

sub cmd_ksb {
  &getarg;
  local($why)=($args);
  $why="d0rks suck big m00se ballZ" unless $why;
  &tell("*\cb0\cb* Must specify a nick to kicksiteban"), return unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&n_hostpat(\$host);
&sl(\"MODE $talkchannel -o+b $newarg *!*\\\@\$host\");
&sl(\"KICK $talkchannel $newarg :$why\");");
}
&addcmd("ksb");

sub cmd_ban {
  &tell("*\cb0\cb* Must specify a nick to ban"), return unless $args;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  while (&getarg, $newarg ne '') {
    &userhost($newarg, "\$host=&n_hostpat(\$host); \$user =~ s/^\\~//;
      &sl(\"MODE $talkchannel +b *!*\$user\\\@\$host\");");
  }
}
&addcmd("ban");

sub cmd_sban {
  &getarg;
  &tell("*\cb0\cb* Must specify a nick to site ban"), return unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&n_hostpat(\$host);
&sl(\"MODE $talkchannel +b *!*\\\@\$host\");");
}
&addcmd("sban");

sub n_unbans {
  local($n, $l)=('0', '');
  foreach (@n0thing_banlist) {
    if ($n<4) {
      $l.=" ".$_;
      $n++;
    } else {
      &sl("MODE $n0thing_channel -bbbb $l");
      $l=$_;
      $n=1;
    }
  }
  &sl("MODE $n0thing_channel -".("b" x $n)." $l");
}

sub cmd_sb {
  &dosplat;
  &getarg;
  $newarg=$talkchannel unless $newarg;
  return unless $newarg;
  $n_svbanchannel=$newarg;
  @n_svbanlist=();
  $n_nxbannb=1;
  &sl("MODE $newarg b");
}
&addcmd("sb");

sub hook_nbbans {
  local($c, $theban, $by)=((split(/ +/, $_[0]))[1, 2, 3]);
  if ($n_nxbannb && &eq($c, $n_svbanchannel)) {
    push(@n_svbanlist, $theban);
    &tell("*\cbb\cb* $c $n_nxbannb: $theban $by");
    $silent=1;
    $n_nxbannb++;
  }
}
&addhook("367", "nbbans");

sub hook_endofbans {
  $n_nxbannb=0;
}
&addhook("368", "endofbans");

sub cmd_cb {
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  &addhook("367", "onecbban");
  &addhook("368", "donebans");
  @n0thing_banlist=();
  $n0thing_channel=$talkchannel;
  &sl("MODE $talkchannel b");
}
&addcmd("cb");

sub hook_onecbban {
  local($theban)=((split(/ +/, $_[0]))[2]);
  push(@n0thing_banlist, $theban);
  $silent=1;
}

sub hook_donebans {
  &remhook("367", "onecbban");
  &remhook("367", "oneubban");
  &remhook("368", "donebans");
  &n_unbans;
}

sub cmd_unban {
  &getarg;
  &tell("*\cb0\cb* Must specify a nick or address to unban"), return 
    unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  if ($newarg =~ /^\d+$/) {
    $n0thing_channel=$talkchannel;
    @n0thing_banlist=();
    while(1) {
      $newarg--;
      &tell("*\cb0\cb* No banlist available for $talkchannel"), return
	unless &eq($talkchannel, $n_svbanchannel);
      &tell("*\cb0\cb* No such ban"), return unless $n_svbanlist[$newarg];
      push(@n0thing_banlist, $n_svbanlist[$newarg]);
      &getarg;
      last unless $newarg;
      &tell("*\cb0\cb* Cannot mix nicks and numbers"), last
	unless $newarg =~ /^\d+$/;
    }
    &n_unbans;
  } else {
    @n0thing_banlist=();
    $n0thing_channel=$talkchannel;
    if ($newarg =~ /\@/) {
      $newarg="*!".$newarg unless $newarg =~ /\!/;
      $n_pat=$newarg;
      &addhook("367", "oneubban");
      &addhook("368", "donebans");
      &sl("MODE $talkchannel b");
    } else {
      &userhost($newarg, "&n_dounban;");
    }
  }
}
&addcmd("unban");
&docommand("^alias ub unban");

sub n_dounban {
  $n_pat=$who."!".$user."\@".$host;
  &addhook("367", "oneubban");
  &addhook("368", "donebans");
  @n0thing_banlist=();
  $n0thing_channel=$talkchannel;
  &sl("MODE $talkchannel b");
}

sub hook_oneubban {
  local($theban)=((split(/ +/, $_[0]))[2]);
  local($tb0)=($theban);
  $theban =~ s/([^\\])\./$1\\./g;
  $theban =~ s/\*/\.\*/g;
  $theban =~ s/([^\.\*\\\w])/\\$1/g;
  push(@n0thing_banlist, $tb0) if ($n_pat =~ /^${theban}$/i);
  $silent=1;
}

sub cmd_fkb {
  &getarg;
  &tell("*\cb0\cb* Must specify a nick to filter kick ban"), return unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  &userhost($newarg, "\$host=&n_hostpat(\$host);
&sl(\"MODE $talkchannel +b *!*\\\@\$host\"); &docommand(\"fk \$host $args\");");
}
&addcmd("fkb");


sub cmd_fk {
  &getarg;
  &tell("*\cb0\cb* Must specify a pattern to kick"), return unless $newarg;
  &tell("*\cb0\cb* You're not on a channel"), return unless $talkchannel;
  $n0thing_channel=$talkchannel;
  $n0thing_kickpat=$newarg;
  $n0thing_kickpat =~ s/([^\\])\./$1\\./g;
  $n0thing_kickpat =~ s/\*/\.\*/g;
  $n0thing_kickpat =~ s/([^\.\*\\\w])/\\$1/g;
  $n0thing_kickmsg=$args || "though names may change each face retains the mask it wore";
  &addhook("352", "dofklist");
  &addhook("315", "donefk");
  &sl("WHO $talkchannel");
}
&addcmd("fk");

sub hook_dofklist {
  local($a)=@_;
  local($c, $c, $u, $h, $s, $n)=split(/ +/, $a);
  (($n."!".$u."\@".$h) =~ /${n0thing_kickpat}/i) && $n ne $nick &&
    &sl("KICK $n0thing_channel $n :$n0thing_kickmsg");
  $silent=1;
}

sub hook_donefk {
  &remhook("352", "dofklist");
  &remhook("315", "donefk");
}

# the msg logger

sub cmd_setaway {
  !$n_isaway && open(NAWAY, ">> ".$n_awayfile) && ($n_isaway=1);
  return unless $n_isaway;
  &me("is away - $args - messages will be logged") if $talkchannel;
  print NAWAY "-- setaway : $args --\n";
  %n_awaysent=();
  $args="\cb" if $args eq '';
  &sl("AWAY :$args");
}
&addcmd("setaway");

sub hook_messages {
  if ($n_isaway) {
    local($sec, $min, $hour)=localtime(time);
    local($w)=$who;
    $min="0".$min if $min =~ /^\d$/;
    print NAWAY ":\cb${who}\cb!${user}\@${host} (${hour}:${min}): $_[0]\n";
    $w =~ tr/A-Z/a-z/;
    &sl("NOTICE $who :Your messages are being logged - n0thing.pl"),
      $n_awaysent{$w}=1 unless $n_awaysent{$w};
  }
} 
&addhook("msg", "messages");

sub hook_dmessages {
  if ($n_isaway) {
    local($sec, $min, $hour)=localtime(time);
    $min="0".$min if $min =~ /^\d$/;
    print NAWAY "=\cb".$_[0]."\cb (${hour}:${min})= ".$_[1]."\n";
  }
}
&addhook("dcc_chat", "dmessages");

sub cmd_setback {
  close(NAWAY) if $n_isaway;
  $n_isaway='';
  &sl("AWAY");
  open(NAWAY, "< ".$n_awayfile) || return;
  print while ($_=<NAWAY>);
  close NAWAY;
  &getuserline("*** Clear saved messages (y/n)? ", "clear? ");
  unlink ($n_awayfile) if /^y/i;
}
&addcmd("setback");

sub cmd_clearmes {
  close(NAWAY) if $n_isaway;
  $n_isaway='';
  unlink ($n_awayfile);
}
&addcmd("clearmes");

# the autoop list, with fully-featured delayed and grouped auto-ops

sub n_addwaitop {
  local($nck, $channel)=@_;
  if ($n_opdelay) {
    local($n)=($nck);
    $channel =~ tr/A-Z/a-z/;
    $n =~ s/(\W)/\\$1/g;
    if ($n_waitops{$channel} !~ /:${n}:/i) {
      $n_waitops{$channel} || ($n_waitops{$channel}=":");
      $n_waitops{$channel}.=$nck.":";
    }
    unless ($n_timerdue) {
      $n_timerdue=1;
      &timer($n_opdelay, "&n_doautoops");
    }
  } else {
    &sl("MODE $channel +o $nck");
  }
}

sub n_remwaitop {
  local($nck, $channel)=@_;
  $channel =~ tr/A-Z/a-z/;
  $nck =~ s/(\W)/\\$1/g;
  $n_waitops{$channel} =~ s/:${nck}:/:/gi;
  delete $n_waitops{$channel} if $n_waitops{$channel} eq ":";
}

sub n_doautoops {
  local($l);
  foreach $c (keys(%n_waitops)) {
    if ($n_waitops{$c} ne ":" && $n_waitops{$c}) {
      $l=$n_waitops{$c};
      $l =~ s/^://;
      $l =~ s/:$//;
      $l =~ tr/:/ /;
      &docommand("o ".$c." ".$l);
    }
    delete $n_waitops{$c};
  }
  $n_timerdue='';
}

sub hook_n_nickchange {
  local($oldnick)=$who;
  $oldnick =~ s/(\W)/\\$1/g;
  foreach $c (keys(%n_waitops)) {
    $n_waitops{$c} =~ s/:${oldnick}:/:$_[0]:/gi;
  }
}
&addhook("nick", "n_nickchange");

sub hook_n_parted {
  &n_remwaitop($who, $_[0]);
}
&addhook("leave", "n_parted");

sub hook_n_quitted {
  local($w)=$who;
  $w =~ s/(\W)/\\$1/g;
  foreach $c (keys(%n_waitops)) {
    $n_waitops{$c} =~ s/:${w}:/:/gi;
    delete $n_waitops{$c} if $n_waitops{$c} eq ":";
  }
}
&addhook("signoff", "n_quitted");

sub hook_n_modechange {
# we only deal with +o, +oo and the like; the worst that can happen
# is that we op someone again
  local ($l)=$_[1];
  return unless $_[0] =~ /^[\#\&]/;
  return unless $l =~ s/^\+o+\s+//;
  foreach $n (split(/ /, $l)) {
    &n_remwaitop($n, $_[0]);
  }
}
&addhook("mode", "n_modechange");

sub autoopped {
  local($nuh)=@_;
  local($p);
  foreach $p (@n_autooplist) {
    return 1 if $nuh =~ /^${p}$/;
  }
  return '';
}

sub addtoops {
  if (&autoopped($who."!".$user."\@".$host)) {
    &tell("*\cb0\cb* $who is already on your list");
  } else {
    $host=&n_hostpat($host);
    $user =~ s/^\~//;
    local($pat)=("*!*".$user."\@".$host);
    &tell("*\cb0\cb* Adding $who as $pat to your autoop list");
    $pat =~ s/([^\\])\./$1\\./g;
    $pat =~ s/\*/\.\*/g;
    $pat =~ s/([^\.\*\\\w])/\\$1/g;
    push(@n_autooplist, $pat);
    &sl("NOTICE $who :You have been added to ${nick}'s autoop list");
    &sl("NOTICE $who :You should feel very honored");
  }
}

sub cmd_addop {
  &getarg;
  &tell("*\cb0\cb* Must specify a nick or pattern"), return unless $newarg;
  if ($newarg =~ /\!.*\@/) {
    &tell("*\cb0\cb* Adding $newarg to your auto-op list");
    $newarg =~ s/([^\\])\./$1\\./g;
    $newarg =~ s/\*/\.\*/g;
    $newarg =~ s/([^\.\*\\\w])/\\$1/g;
    push(@n_autooplist, $newarg);
  } else {
    &userhost($newarg, "&addtoops;");
  }
}
&addcmd("addop");

sub hook_joined {
  local($c)=($_[0]);
  $c =~ tr/A-Z/a-z/;
  &n_addwaitop($who, $c) 
    if ($n_autoops && $haveops{$c} && &autoopped($who."!".$user."\@".$host));
}
&addhook("join", "joined");

sub cmd_autoop {
  &getarg;
  if ($newarg =~ /^on$/) {
    $n_autoops=1;
  } elsif ($newarg =~ /^off$/) {
    $n_autoops='';
  }
  &tell("*\cb0\cb* Auto-op is ".($n_autoops?"on":"off"));
}
&addcmd("autoop");

sub cmd_delay {
  $n_opdelay=$args if $args =~ /^\d+$/;
  &tell("*\cb0\cb* Auto-op delay is set to: $n_opdelay");
}
&addcmd("delay");

sub cmd_listop {
  local($n, $p, $q)=(0);
  &tell("*\cb0\cb* That's the people in your autoop list:");
  foreach $p (@n_autooplist) {
    $n++;
    $q=$p;
    $q =~ s/\\//g;
    $q =~ s/\.\*/*/g;
    &tell("*\cb0\cb* $q");
  }
  &tell("*\cb0\cb* which makes.. uhm... $n people, I think");
}
&addcmd("listop");

sub n_opped {
  &tell("*\cb0\cb* $_[1] is ".(&autoopped($_[0])?"":"not ")."on your auto-op list");
}

sub cmd_opped {
  &getarg;
  if (!$newarg) {
    &tell("*\cb0\cb* Must specify a nick or address");
  } elsif ($newarg =~ /\@/) {
    $newarg='*!'.$newarg if ($newarg !~ /\!/);
    &n_opped($newarg, $newarg);
  } else {
    &userhost($newarg, "&n_opped(\"${newarg}!\${user}\\\@\${host}\", \"$newarg\");");
  }
}
&addcmd("opped");

sub n_remop {
  local($nuh)=($who."!".$user."\@".$host);
  @n_autooplist=grep(($nuh !~ /^${_}$/), @n_autooplist);
}

sub cmd_remop {
  &getarg;
  if (!$newarg) {
    &tell("*\cb0\cb* Must specify a nick or address");
  } elsif ($newarg =~ /\@/) {
    $newarg='*!'.$newarg if ($newarg !~ /\!/);
    &tell("*\cb0\cb* Time to remove $newarg from the autoop list");
    @n_autooplist=grep(($newarg !~ /^${_}$/), @n_autooplist);
  } else {
    &tell("*\cb0\cb* Time to remove $newarg from the autoop list");
    &userhost($newarg, "&n_remop;");
  }
}
&addcmd("remop");

sub cmd_clearop {
  @n_autooplist=();
  &tell("*\cb0\cb* Auto-op list cleared!");
}
&addcmd("clearop");

# saving the settings

sub cmd_sve {
  local($p);
  if (!open(SVE, "> ".$n_svefile)) {
    &tell("*\cbE\cb* can't write to save file");
    return;
  }
  print SVE ($n_autoops ? "1" : "0"), "\n";
  print SVE ($n_autorejoin ? "1" : "0"), "\n";
  print SVE $n_pingmsg, "\n";
  print SVE $finger, "\n";
  print SVE join(" ", keys(%notify)), "\n";
  print SVE join(" ", @n_autooplist), "\n";
  print SVE ($n_slowserver ? "1" : "0"), "\n";
  print SVE $n_opdelay, "\n";
  print SVE $n_quitmsg, "\n";
  close SVE;
  &tell("*\cb0\cb* save completed!");
}
&addcmd("sve");

sub cmd_quit {
  if ($args eq '') {
    &docommand("/QUIT $n_quitmsg");
  } else {
    &docommand("/QUIT $args");
  }
}
&addcmd("quit");
&docommand("^alias bye quit");
&docommand("^alias exit quit");
&docommand("^alias signoff quit");

# some online help

sub cmd_nhelp {
  &docommand("help n0thing".$args);
}
&addcmd("nhelp");

&addhelp("n0thing", "This is \cbn0thing.pl\cb for sirc, by \cborabidoo\cb
 
For the list of n0thing.pl's general functions, type /nhelp general
For the list of n0thing.pl's channel functions, type /nhelp channel
For the list of n0thing.pl's file functions, type /nhelp files
For the list of n0thing.pl's settings, type /nhelp settings

Arguments between []'s are always optional.
 
For comments, bug reports, ideas:  email roger.espel.llima\@ens.fr");

&addhelp("n0thinggeneral", "List of \cbn0thing.pl\cb's functions:

/ver <nick>             gets version info about <nick>
/tim <nick>             gets <nick>'s local time
/setaway <reason>       sets yourself away, logs messages
/setback                sets yourself back, shows messages
/clearmes               erases saved messages
/ig <nick>              ignores <nick>
/sig <nick>             ignores <nick>'s site
/unig                   undoes your last /ig
/sve                    saves your settings and auto-op and notify list");

&addhelp("n0thingchannel", "List of \cbn0thing.pl\cb's channel functions:

/sb [<channel>]         shows ban list on a channel [current one]
/ban <nick> [<nick>...] bans on current channel
/sban <nick>            bans the whole site on current channel
/ub <nick>|<address>    unbans on current channel
/ub <number> [<nmbr>..] removes bans by number after a /sb
/cb                     clears all bans on current channel
/l                      short list of people on the current channel
/open [<channel>]       removes weird modes on the channel [current one]
/kb <nick> [<reason>]   kicks and bans
/ksb <nick> [<reason>]  kicks and site-bans
/fk <filter> [<reasn>]  kicks all users matching the filter
/fkb <nick> [<reasn>]   site-bans and kicks all users from the same site");

&addhelp("n0thingsettings", "List of \cbn0thing.pl\cb's settings:
/rejoin [on|off]        toggles auto-rejoin on kick
/autoop [on|off]        toggles auto-ops
/ss [on|off]            toggles slow-server mode (turn it on when you have
                        a slow connection with your server)
/setping [<message>]    set or see your ping reply
/setfing [<message>]    set or see your /ctcp finger reply
/setquit [<mesg>|none]  set or see your default /quit message
/addop <nick>|<pattrn>  adds user to your auto-op list
/remop <nick>|<address> removes user from your auto-op list
/opped <nick>|<address> checks if nick/address is on your autoop list
/clearop                clears your auto-op list
/listop                 lists your auto-op list
/delay			sets your auto-op delay
/sve                    saves your settings and auto-op and notify list");

&addhelp("n0thingfiles", "List of \cbn0thing.pl\cb's file-oriented functions:
/dc [<nick>]            starts a dcc chat [last offered]
/dg [<nick>] [<file>]   gets a file via dcc [last offered]
/ds <nick> <file>       sends a file via dcc
/cdc <nick>             closes a /dcc chat
/cds <nick>             closes a /dcc send connection
/cdg <nick>             closes a /dcc get connection
/ex <command>           \"shortcut\" for /system
/ls [<args>]            lists files
/cat <files>            shows files
/rm <files>             deletes files
/ps <options>           lists processes
/mail                   reads your mail  (you'll get disconnected from the
                        server if this takes more than a few minutes; exit
                        with 'q')");

# reading the saved settings

if (open(NOTHING, "< ".$n_svefile)) {
  local($n, $l);
  chop($n_autoops=<NOTHING>);
  chop($n_autorejoin=<NOTHING>);
  chop($n_pingmsg=<NOTHING>);
  chop($finger=<NOTHING>);
  chop($l=<NOTHING>);
  %notify=();
  foreach $n (split(' ', $l)) {
    &docommand("^NOTIFY ".$n);
  }
  chop($l=<NOTHING>);
  @n_autooplist=split(' ', $l);
  chop($n_slowserver=<NOTHING>);
  chop($n_opdelay=<NOTHING>);
  $n_opdelay=5 if $n_opdelay eq '';
  chop($n_quitmsg=<NOTHING>);
  close(NOTHING);
}

&print("*\cb0\cb* \cborabidoo\cb's *\cvn0thing.pl\cv* for sirc loaded, type /nhelp for help");

